<%-- 
 * @start_prolog@
 *  Version: %Z% %I% %W% %E% %U% [%H% %T%]
 * ============================================================================
 * IBM Confidential OCO Source Materials
 * 
 * 5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70 Copyright IBM Corp. 2011
 * 
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 * ============================================================================
 * @end_prolog@
 * 
 * Change activity:
 *
 * Reason          Date    Origin    Description
 * --------------  ------  --------  -------------------------------------------
 * S5140		   111220  mattclar	 WXS Definition Security properties panel behaviour
--%>

<%@ page import="java.util.*"%>
<%@ page import="com.ibm.ws.console.sibx.sibxxsresources.*"%>
<%@ page import="com.ibm.ws.console.core.*"%>
<%@ page import="com.ibm.ws.console.core.form.AbstractDetailForm"%>

<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tiles.tld" prefix="tiles" %>

<tiles:useAttribute id="property" name="property" classname="java.lang.String"/>
<tiles:useAttribute id="formBean" name="bean" classname="java.lang.String"/>

<bean:define id="bean" name="<%=formBean%>"/>
<bean:define id="securityEnabled" name="<%=formBean%>" property="securityEnabled" type="java.lang.Boolean"/>
<bean:define id="credentialGenerator" name="<%=formBean%>" property="credentialGenerator" type="java.lang.String"/>
<bean:define id="authAlias" name="<%=formBean%>" property="authAlias" type="java.lang.String"/>

<script>
   
  //Run when security enabled check box is checked/unchecked.
  function checkSecurity(selection)
  {
      var authAliasSpecify = document.getElementById("authAliasSpecify");
      var authAliasRequiredImage = document.getElementById("XSDefinition.security").tBodies[0].rows[3].cells[0].getElementsByTagName("img")[0];

      if (selection.checked) 
      {
          document.getElementById("credentialGenerator").disabled = false;
          document.getElementById("credentialGeneratorRequiredImage").style.visibility = 'visible';
          
          // if the Credential Generator value is set to userpassword then enable the authAlias dropdown
          if(document.getElementById("credentialGenerator").value == 'UserPassword')
          {
          	document.getElementById("authAliasSelect").disabled = false;
          	authAliasRequiredImage.style.visibility = 'visible';

            if(!authAliasSpecify.style.visibility == 'hidden') {
              // then disable it
              authAliasSpecify.disabled = false;
            }
          }
      }
      else
      {
          document.getElementById("credentialGenerator").disabled = true;
          document.getElementById("credentialGeneratorRequiredImage").style.visibility = 'hidden';
          document.getElementById("authAliasSelect").disabled = true;
          authAliasRequiredImage.style.visibility = 'hidden';

          // handle any possible showing of the authalias specify text box
          // if it is currently visible
          if(!authAliasSpecify.style.visibility == 'hidden') {
              // then disable it
              authAliasSpecify.disabled = true;
          }
      }
   }

  //Run when dropdown value for Credential Generator is changed 
  function toggleCredentialGenerator(selection)
  {
      var authAliasSpecify = document.getElementById("authAliasSpecify");
      var authAliasRequiredImage = document.getElementById("XSDefinition.security").tBodies[0].rows[3].cells[0].getElementsByTagName("img")[0];

      //if UserPassword enable the AuthAlias dropdown
  	  if(selection.value == 'UserPassword')
  	  {
  	      document.getElementById("authAliasSelect").disabled = false;
  	      authAliasRequiredImage.style.visibility = 'visible';

          if(!authAliasSpecify.style.visibility == 'hidden') {
              // then disable it
              authAliasSpecify.disabled = false;
          }
  	  }
  	  // else either WSToken or Select so set authAlias to false
  	  else
  	  {
          document.getElementById("authAliasSelect").disabled = true;
          authAliasRequiredImage.style.visibility = 'hidden';
          
          // handle any possible showing of the authalias specify text box
          // if it is currently visible
          var authAliasSpecify = document.getElementById("authAliasSpecify");
          if(!authAliasSpecify.style.visibility == 'hidden') {
              // then disable it
              authAliasSpecify.disabled = true;
          }    
  	  }
   }

</script>

  <%
    boolean securityDisabled = false;
    boolean credGenDisabled = false;
    String credGenImageStyle = "visibility: visible";
    
    // to track when switching between Credential Generator type
    boolean authAliasDisabled = false;
    String authAliasImageStyle = "visibility: visible";

    if(securityEnabled == Boolean.FALSE)
    {
    	securityDisabled = true;
    	credGenDisabled = true;
    	credGenImageStyle = "visibility: hidden";
    }
    
    // if UserPassword then enable selecting of auth alias, else don't
    if(!credentialGenerator.equals("UserPassword"))
    {
        authAliasDisabled = true;
        authAliasImageStyle = "visibility: hidden";
    }
   
    // establish the disabled value for the authalias dropdown based upon security enabled and UserPassword being selected for the Credential Generator
    Boolean disabledAuthAliasBool = Boolean.valueOf(securityDisabled ||  authAliasDisabled);
%>

    <tr>
        <td class="table-text">
            <html:checkbox property="securityEnabled" name="<%=formBean%>" styleId="securityEnabled" onclick="checkSecurity(this);"/>
                <label for="securityEnabled" title="<bean:message key="xs.securityEnabled.desc"/>">
                    <bean:message key="xs.securityEnabled"/>
                </label>
        </td>
    </tr>
    <tr>
        <td valign="top" class="table-text" title="<bean:message key="xs.credentialGenerator.desc"/>">
            <span class="requiredField" title="<bean:message key="xs.credentialGenerator.desc"/>">
                <label for="credentialGenerator" title="<bean:message key="xs.credentialGenerator.desc"/>">
                    <img id="credentialGeneratorRequiredImage" src="images/attend.gif" width="8" height="8" align="absmiddle" style="<%=credGenImageStyle%>" alt="<bean:message key="information.required"/>">
                    <bean:message key="xs.credentialGenerator"/><br>
                </label>      
                <html:select property="credentialGenerator" name="<%=formBean%>" styleId="credentialGenerator" onchange="toggleCredentialGenerator(this);" disabled="<%=credGenDisabled%>">
                    <html:option value="Select"><bean:message key="xs.credentialGenerator.select"/></html:option>
                    <html:option value="UserPassword"><bean:message key="xs.credentialGenerator.userPassword"/></html:option>
                    <html:option value="WSToken"><bean:message key="xs.credentialGenerator.wsToken"/></html:option>
                </html:select>
            </span>          
        </td>
    </tr>
    <tr>
        <tiles:insert page="/com.ibm.ws.console.sib.sibresources/commonSelectableTextDropdown.jsp" flush="false">
            <tiles:put name="label" value="xs.auth.alias" />
            <tiles:put name="isRequired" value="yes" />
            <tiles:put name="units" value=""/>
            <tiles:put name="size" value="30" />
            <tiles:put name="desc" value="xs.auth.alias.desc" />
            <tiles:put name="property" value="authAlias" />
            <tiles:put name="bean" value="<%=formBean%>" />
            <tiles:put name="readOnly" value="false" />
            <tiles:put name="update" value="<%=new Boolean(false)%>" />
            <tiles:put name="initiallyDisabled" value="<%=disabledAuthAliasBool%>" />
        </tiles:insert>
    </tr>

<script>
    // get the authAlias required image
    var authAliasRequiredImage = document.getElementById("XSDefinition.security").tBodies[0].rows[3].cells[0].getElementsByTagName("img")[0];

    var securityCheckBox = document.getElementById("securityEnabled");
    var credentialDropdown = document.getElementById("credentialGenerator");
    // if the populated fields either have security unchecked, or when checked the credential generator is not set to UserPassword
    // then we need to set required image to be invisible
    if(!(securityCheckBox.checked && (credentialDropdown.value == "UserPassword"))) {
        authAliasRequiredImage.style.visibility = 'hidden';
    }      
</script>
